import 'package:flutter/material.dart';
import 'package:hub/shared/components/molecules/menu/index.dart';

enum MenuEntries {
  home,
  drawer,
  AboutProperty;

  List<BaseEntry> get getValues {
    switch (this) {
      case MenuEntries.home:
        return HomeMenuEntries.values.toList();
      case MenuEntries.drawer:
        return DrawerMenuEntries.values.toList();
      case MenuEntries.AboutProperty:
        return AboutPropertyMenuEntries.values.toList();
    }
  }
}

class MenuEntryFactory {
  static List<BaseEntry> createMenuEntry(BaseEntry type) {
    switch (type) {
      case HomeMenuEntries _:
        return HomeMenuEntries.values.toList();
      case DrawerMenuEntries _:
        return DrawerMenuEntries.values.toList();
      case AboutPropertyMenuEntries _:
        return AboutPropertyMenuEntries.values.toList();
      default:
        throw ArgumentError('Invalid menu entry type');
    }
  }

  List<BaseEntry> buildMenuEntry(BaseEntry type) {
    return createMenuEntry(type);
  }
}
